﻿Imports System.Windows.Controls.Primitives


Class MainView
    Public Property Nodes As List(Of Node)
    Public Property Elements As List(Of Element)

    Public Sub New()

        ' Dieser Aufruf ist für den Designer erforderlich.
        InitializeComponent()

        DataContext = New MainVM

    End Sub
    Private Sub Thumb_Drag(sender As Object, e As DragDeltaEventArgs)
        Dim thumb As Thumb = TryCast(sender, Thumb)
        If thumb Is Nothing Then Exit Sub

        Dim node As Node = DirectCast(thumb.DataContext, Node)
        If node Is Nothing Then Exit Sub

        node.X += e.HorizontalChange
        node.Y += e.VerticalChange
    End Sub

    Private Function GetNodeUnderMouse() As Node
        Dim item As ContentPresenter = TryCast(Mouse.DirectlyOver, ContentPresenter)
        If item Is Nothing Then Return Nothing
        Dim node As Node = TryCast(item.DataContext, Node)
        Return node
    End Function

    Private Sub ListBox_PreviewMouseDown(sender As Object, e As MouseButtonEventArgs)
        Dim vm As MainVM = TryCast(Me.DataContext, MainVM)

        If vm.CreatingNewElement Then
            Dim node As Node = GetNodeUnderMouse()
            Dim element As Element = TryCast(vm.SelectedObject, Element)
            If node IsNot Nothing AndAlso element IsNot Nothing Then
                element.StartingNode = node
                node.IsHighlighted = True
                e.Handled = True
                Exit Sub
            End If
            If vm.SelectedObject IsNot Nothing Then
                vm.SelectedObject.IsNew = False
            End If
            vm.CreatingNewNode = False
            vm.CreatingNewElement = False
        End If
    End Sub

    Private Sub ListBox_PreviewMouseMove(sender As Object, e As MouseEventArgs)
        Dim lb As ListBox = TryCast(sender, ListBox)
        Dim vm As MainVM = TryCast(lb.DataContext, MainVM)
        If lb Is Nothing OrElse vm Is Nothing Then Exit Sub

        If vm.SelectedObject IsNot Nothing Then
            If TypeOf vm.SelectedObject Is Node AndAlso vm.SelectedObject.IsNew Then
                vm.SelectedObject.X = e.GetPosition(lb).X
                vm.SelectedObject.Y = e.GetPosition(lb).Y
            ElseIf TypeOf vm.SelectedObject Is Element AndAlso vm.SelectedObject.IsNew Then

                Dim node As Node = GetNodeUnderMouse()
                If node Is Nothing Then Exit Sub
                Dim element As Element = TryCast(vm.SelectedObject, Element)
                If element.StartingNode IsNot Nothing AndAlso node IsNot element.StartingNode Then
                    element.EndingNode = node
                End If
            End If
        End If
    End Sub
End Class
