﻿Public Class Node : Inherits DesignerObject
    Private _x As Double = 0
    Public Overrides Property X As Double
        Get
            Return _x
        End Get
        Set(value As Double)
            ' Grid Snapping:
            ' this actually "rounds" the value so that it will always be a multiple of 50.
            _x = (Math.Round(value / 50.0)) * 50
            OnPropertyChanged("X")
        End Set
    End Property

    Private _y As Double = 0
    Public Overrides Property Y As Double
        Get
            Return _y
        End Get
        Set(value As Double)
            ' Grid Snapping:
            ' this actually "rounds" the value so that it will always be a multiple of 50.
            _y = (Math.Round(value / 50.0)) * 50
            OnPropertyChanged("Y")
        End Set
    End Property

    Private _isHighlighted As Boolean = False
    Public Property IsHighlighted As Boolean
        Get
            Return _isHighlighted
        End Get
        Set(value As Boolean)
            _isHighlighted = value
            OnPropertyChanged("IsHighlighted")
        End Set
    End Property
End Class